2006-11-27  Ben Asselstine  <benasselstine@canada.com>
	    Thomas Schwinge  <tschwinge@gnu.org>

	[task #5994 --- ``rpctrace: Consider PREFIX/shared/msgids/*.msgids by
	default'']
	* rpctrace.c: Include <stdbool.h> and <argz.h>.
	(scan_msgids_dir): New function, factored out of the <case 'I'> code,
	with the change of not directly parsing the files, but instead adding
	them to an argz vector.
	(STD_MSGIDS_DIR): New definition.
	(options): Add new `--nostdinc' option.
	(main): Handle that new option.  Utilize an argz vector.  Include the
	files in STD_MSGIDS_DIR unless prohibited by the new option.
	* Makefile (rpctrace-CPPFLAGS): New variable.

2006-07-24  Ben Asselstine  <benasselstine@canada.com>

	[bug #17135]
	* psout.c (psout): Exit returning `1' if there aren't any applicable
	processes.

2006-03-15  Thomas Schwinge  <tschwinge@gnu.org>

	* ps.c (current_tty_name): Don't declare as static.
	* rpctrace.c (print_contents): Don't use ?: as a lvalue.
	(msgids_file_p): Don't declare as static.

2005-07-26  Alfred M. Szmidt  <ams@gnu.org>

	* rpctrace.c: Include <fnmatch.h>, <sys/stat.h>, and <dirent.h>.
	(main, options): Renamed the option `-I' to `-i', and
	reimplemented `-I' to search a given directory for message ID
	files.
	(main): Variable `err' removed.

2004-09-21  Alfred M. Szmidt  <ams@kemisten.nu>

	* fsysopts.c (doc): Changed `--remount' to `--update'.

	* mount.c (argp_opts): Enabled never-enabled options and added
	long versions: --verbose/-v, --remount/--update/-u,
	--writable/-w, --readonly/-r and --options/-o.	Reported by
	Ben Asselstine.

	* mount.c (parse_opt): For -u, use "update" instead of the deprecated
	"remount" argument.

2004-03-09  Marcus Brinkmann  <marcus@gnu.org>

	* login.c (main): Remove extern declaration and invocation of
	_argp_unlock_xxx.

2004-03-14  Marcus Brinkmann  <marcus@gnu.org>

	* storeread.c (main): Call argp_usage if store is not set at
	ARGP_KEY_END.

2003-08-17  Marcus Brinkmann  <marcus@gnu.org>

	* rpctrace.c: Include <stddef.h>.
	(struct traced_info): Change type of LOCP to hurd_ihash_locp_t.
	(msgid_ihash): Change type to struct hurd_ihash, and initialize
	with HURD_IHASH_INITIALIZER, don't set cleanup here.
	(traced_names): Likewise.
	(main): Call hurd_ihash_set_cleanup for msgid_ihash.  Don't create
	traced_names.
	(parse_msgid_list): Call hurd_ihash_add instead ihash_add.
	(new_send_wrapper): Likewise.
	(msgid_info): Likewise.  Call hurd_ihash_find instead ihash_find.
	(rewrite_right): Likewise.
	(traced_dropweak): Call hurd_ihash_locp_remove instead
	ihash_locp_remove.

2003-10-26  Roland McGrath  <roland@frob.com>

	* storeread.c (doc, arg_doc): Make arrays, not pointers; make const.
	(doc): Add leading short description line before \v.

	* rpctrace.c (docs, args_doc): Make arrays, not pointers.
	(doc): Remove "\v.".  Reported by Alfred M. Szmidt <ams@kemisten.nu>.

2002-06-16  James A. Morrison  <ja2morri@uwaterloo.ca>

	* vmstat.c (vm_state_refresh): Use memset instead of bzero.
	(main): Likewise.

2002-09-17  Marcus Brinkmann  <marcus@gnu.org>

	* console-ncurses.c: File removed (the ncursesw console client is
	now a driver in the console-client).
	* Makefile: Revert 2002-08-22 change:
	Do not include`../config.make'.
	(targets) [LIBNCURSES]: Removed.
	(SRCS) [LIBNCURSES]: Likewise.
	(HURDLIBS) [LIBNCURSES]: Likewise.
	(console-ncurses): Target removed.
	(console-ncurses-CPPFLAGS): Removed.
	(console-ncurses-LDLIBS): Likewise.

2002-09-09  Marcus Brinkmann  <marcus@gnu.org>

	* console-ncurses.c (cons_vcons_set_scroll_lock): New function.

	* console-ncurses.c (console_switch): Keep a reference to the port
	instead refering to it by number.

	* console-ncurses.c: New global variable global_lock.
	(main): Initialize global_lock.
	(cons_vcons_activate): Removed.
	(console_switch): New function.
	(cons_vcons_add): New function.
	(input_loop): Call console_switch, not cons_switch.  Do not take
	active_vcons lock but global_lock.
	(cons_vcons_update): Take global lock.
	(cons_vcons_set_cursor_pos): Likewise.
	(cons_vcons_set_cursor_status): Likewise.
	(cons_vcons_scroll): Likewise.
	(cons_vcons_write): Likewise.
	(cons_vcons_beep): Likewise.
	(cons_vcons_flash): Likewise.

2002-08-29  Marcus Brinkmann  <marcus@gnu.org>

	* console-ncurses.c (main): Call endwin () before bailing out
	because of an error.
	(cons_vcons_write): Use getyx and wmove on stdscr instead getsyx
	and setsyx (which operate on newscr, and mess up the cursor
	anyway, probably because we don't commit the change immediately).
	Submitted by David Walter <dwalter@syr.edu>.

2002-08-22  Marcus Brinkmann  <marcus@gnu.org>

	* Makefile: Include `../config.make' early on to get LIBNCURSESW
	variable from configure before including Makeconf.
	(targets) [LIBNCURSES]: Add console-ncurses.
	(SRCS) [LIBNCURSES]: Add console-ncurses.c.
	(HURDLIBS) [LIBNCURSES]: Add cons.
	(console-ncurses): New target.
	(console-ncurses-CPPFLAGS): New variable.
	(console-ncurses-LDLIBS): Likewise.

2002-08-18  Roland McGrath  <roland@frob.com>

	* fakeroot.sh: Dont use "exec" command, since the original script
	does not and some users use sh syntax here and not just commands.

2002-06-25  Roland McGrath  <roland@frob.com>

	* ping.c: File removed.
	* Makefile (targets, SRCS): Remove it.
	(ping-CPPFLAGS, INSTALL-ping-ops, ping): And all its little friends.

2002-06-14  Roland McGrath  <roland@frob.com>

	* Makefile (INSTALL-vminfo-ops): Variable removed (no setuid).

	* vmstat.c (ensure_def_pager_info): If get_privileged_ports fails with
	EPERM, try to open /servers/default-pager instead.
	* Makefile (INSTALL-vmstat-ops): Variable removed (no setuid).

2002-06-13  Roland McGrath  <roland@frob.com>

	* vminfo.c: Use `z' modifier format modifier for address/size values.

2002-06-08  Roland McGrath  <roland@frob.com>

	* ftpdir.c (pdirent): Use %lld format for off_t value.

2002-05-28  Roland McGrath  <roland@frob.com>

	* fakeauth.c (idvec_copyout): Fix argument type.

	* rpctrace.c (print_data): Use if instead of switch to handle FP type
	sizes, in case double == long double.

	* storeinfo.c (print_store): Use %z format.

	* pids.c (add_fn_pids): unsigned -> size_t
	* w.c (add_utmp_procs): Likewise.
	* login.c (add_canonical_host): Likewise.
	* ps.c (main): Likewise.
	* login.c (add_entry, main): Likewise.
	* settrans.c (main): int -> size_t
	* showtrans.c (main): Likewise.
	* fsysopts.c (main): Likewise.
	* vmstat.c (main): Use int for FWIDTHS.
	* ping.c (main): size_t -> socklen_t
	* fakeauth.c (S_auth_getids, S_auth_makeauth,
	S_auth_server_authenticate): u_int -> size_t
	* showtrans.c (main): Cast field width/precision args to int.

2002-05-20  Ognyan Kulev  <ogi@fmi.uni-sofia.bg>

	* rpctrace.c (parse_msgid_list): Fixed the check that tests if we
	read exactly 3 fields from each line.

2002-05-13  Marcus Brinkmann  <marcus@gnu.org>

	* fakeauth.c (main): Register NEWTASK as a child with the proc
	server.

2002-05-13  Marcus Brinkmann  <marcus@gnu.org>

	* devprobe.c: Include <version.h>.
	(argp_program_version): New variable.
	* storecat.c: Include <version.h>.
	(argp_program_version): New variable.
	* storeread.c: Include <version.h>.
	(argp_program_version): New variable.
	* gcore.c: Include <version.h>.
	(argp_program_version): New variable.

2002-05-12  Roland McGrath  <roland@frob.com>

	* fakeroot.sh: Inside the chroot'd fakeauth environment,
	run a shell that chdir's to what was our original current
	directory (by name) before exec'ing the user's command.

	* fakeauth.c (main): Don't use posix_spawnp.  Use _hurd_exec instead.

2002-05-06  Marcus Brinkmann  <marcus@gnu.org>

	* settrans.c (main): Return 0 instead of using break (which only
	gets us out of the while loop).

2002-05-05  Marcus Brinkmann  <marcus@gnu.org>

	* fakeauth.c (main): Add ARGP_IN_ORDER to argp_parse invocation.
	(main: parse_opt): New function.
	(main): Set parser in ARGP to parse_opt.

2002-05-04  Roland McGrath  <roland@frob.com>

	* fakeauth.c (main): Update doc strings, clean up argp_parse call.

	* fakeroot.sh: New file.
	* Makefile (targets, special-targets, SRCS): Add it.

	* settrans.c (options): Add --chroot/-C option.
	(main_opt): Parse that option, take following args until "--"
	as a command to exec chroot'd to the translated node.

2002-05-03  Roland McGrath  <roland@frob.com>

	* msgport.c (str2flags): Add break after default: label.

	* vmstat.c (print_val): Use %lld printf format for val_t.

	* fakeauth.c: New file.
	* Makefile (fakeauth): New target.
	(targets): Add it.
	(SRCS): Add fakeauth.c.
	(auth-MIGSFLAGS, fakeauth-CPPFLAGS, authServer-CPPFLAGS,
	auth_requestUser-CPPFLAGS): New variables.

	* shd.c: Include <error.h> for `error' decl.

	* Makefile (rpctrace): Put libthreads before libports.

2002-03-23  James A. Morrison  <ja2morri@uwaterloo.ca>

	* rpctrace.c (parse_msgid_list): Use ERR, not errno.
	* shd.c (reap): Use error, not perror.
	(command): Likewise.
	(main): Likewise.
	(run): Use error, not perror.  Use ERR, not errno.

2002-01-30  Roland McGrath  <roland@frob.com>

	* rpctrace.c (struct msgid_info): New type.
	(msgid_ihash_cleanup): Updated to use it.
	(parse_msgid_list): Use it to also record subsystem name in table.
	(msgid_info): New function, guts of msgid_name.
	(msgid_name): Use that.
	(msgid_display, msgid_trace_replies): New stub functions.
	(trace_and_forward): Use them to conditionalize tracing and printing.

2002-01-29  Roland McGrath  <roland@frob.com>

	* rpctrace.c (options): Add -I/--rpc-list.
	(msgid_ihash): New static variable.
	(msgid_ihash_cleanup): New function.
	(parse_msgid_list, magid_name): New functions.
	(main: parse_opt): Grok -I using parse_msgid_list.
	(trace_and_forward, print_request_header, print_reply_header):
	Look up msgh_id values using msgid_name and print strings if possible.

2002-01-04  Roland McGrath  <roland@frob.com>

	* msgport.c (str2flags): Use const in argument type; make static.
	Set O_CREAT for "w" mode.  Grok "a" to set O_APPEND.
	(cmd_setfd): Always call str2flags, giving it a default string.
	(cmd_stdin, cmd_stdout, cmd_stderr): Likewise.
	(cmd_options): Update doc strings.

2002-01-02  Roland McGrath  <roland@frob.com>

	* rpctrace.c (traced_spawn) [KERN_INVALID_LEDGER]:
	Pass extra arguments to task_create for OSF variant.
	* shd.c (run): Likewise.

2001-12-30  Roland McGrath  <roland@frob.com>

	* storeread.c (main): Fix argument order in `error' call.

2001-12-28  Roland McGrath  <roland@frob.com>

	* storeinfo.c (main): Pass STORE_NO_FILEIO to store_create.

2001-11-23  Roland McGrath  <roland@frob.com>

	* gcore.c: New file (previously ../exec/gcore.c).  Update the code.
	* Makefile (targets): Add gcore.

2001-10-14  Roland McGrath  <roland@frob.com>

	* rpctrace.c (trace_and_forward): Move assert on expected port type to
	after check for notifications (which always use fake send-once rights).

2001-08-10  Roland McGrath  <roland@frob.com>

	* showtrans.c (main): Use %.*s formats to be robust in the
	face of an unterminated argz in a translator setting.

2001-06-15  Neal H Walfield  <neal@cs.uml.edu>

	* settrans.c (options): New option `--orphan'.
	Fix other comments to avoid confusion.
	(main): Add FS_TRANS_ORPHAN to ACTIVE_FLAGS if `--orphan' is
	specified.

2001-06-06  Roland McGrath  <roland@frob.com>

	* rpctrace.c (trace_and_forward): Assert that INFO has the same port
	right type as the right we looked up.  Don't consider a message a
	reply unless its receiver is a send-once right.

	* rpctrace.c (print_reply_header): Don't call unfinished_line if
	expected_reply_port is null, indicating the last line was finished as
	a simpleroutine.

2001-03-31  Roland McGrath  <roland@frob.com>

	* pids.h: Fix obsolescent #endif syntax.

2001-02-27  Roland McGrath  <roland@frob.com>

	* rpctrace.c: Overhaul output handling.

2001-02-25  Roland McGrath  <roland@frob.com>

	* storecat.c: Include <stdlib.h> for decls.
	* w.c: Include <time.h> for decls.

2001-01-17  Neal H Walfield  <neal@cs.uml.edu>

	* mount.c (do_mount): Conform to new fshelp_start_translator
	semantics.

	* settrans.c (main): Conform to new fshelp_start_translator
	semantics therby allowing us to print the pid of the an
	active translator.

2001-01-08  Marcus Brinkmann  <marcus@gnu.org>

	* storeread.c (main): Change type of addr to store_offset_t,
	also for first argument of local function dump.
	Add comment about store->size as len parameter for store_read.
	Use atoll instead atoi for addr argument.

	* storeinfo.c (print_store): Remove local function pint, add two
	similar functions psiz and poff, accepting and printing a size_t
	or store_offset_t respectively.
	Use psiz to print block_size, poff to print blocks and size of
	store.
	Use %Ld instead %ld to print runs.

	* storecat.c (main): Change type of addr and left to store_offset_t.

2000-10-18  Marcus Brinkmann  <marcus@gnu.org>

	* devprobe.c (main): Call device_close before freeing the device
	port.

2000-07-27  Thomas Bushnell, BSG  <tb@mit.edu>

	* portinfo.c: Comment out unimplemented argument
	`--show-targets'.  Reported by
	Marcus.Brinkmann@ruhr-uni-bochum.de.

2000-07-26  Mark Kettenis  <kettenis@gnu.org>

	* Makefile (HURDLIBS): Reorder libs such that the threads lib
	comes before the ports lib.  This makes sure the functions in
	libthreads properly override the stubs in libports with the new
	dynamic linker semantics in glibc 2.2.

2000-03-17  Thomas Bushnell, BSG  <tb@mit.edu>

	* frobauth-mod.c (frobauth_modify): Don't use MOVE_SEND in Hurd RPC.
	* msgport.c (do_setfd, cmd_chcwdir, cmd_cdroot, cmd_chcrdir):
	Likewise.

2000-02-08  Roland McGrath  <roland@baalperazim.frob.com>

	Remove the su utility, which is incompatible with traditional su
	as provided by sh-utils and used by some portable shell scripts.
	The Hurdish su functionality is available as `setauth --save'.
	* su.c: File removed.
	* Makefile (targets): Remove su.
	(SRCS): Remove su.c.
	(su): Target removed from various dependency rules.
	(su-LDLIBS): Variable removed.
	* unsu.c (doc): Refer to setauth --save rather than su.

2000-01-22  Roland McGrath  <roland@baalperazim.frob.com>

	* nonsugid.c (get_nonsugid_ids): Remove saved set IDs from available
	sets before merging effective sets.

1999-11-20  Roland McGrath  <roland@baalperazim.frob.com>

	* storeinfo.c (print_store: pstr): Add const to parameter type.

1999-11-19  Roland McGrath  <roland@baalperazim.frob.com>

	* mount.c: New file.
	* mount.sh: File removed.
	* Makefile (special-targets): Remove mount.
	(SRCS): mount.sh -> mount.c
	(mount): Add deps on ../sutils/fstab.o, ../sutils/clookup.o,
	libfshelp and libports.
	(../sutils/fstab.o ../sutils/clookup.o): Rule to build in ../sutils.

1999-11-18  Roland McGrath  <roland@baalperazim.frob.com>

	* vmstat.c (BADVAL): New macro.
	(SWAP_FIELD): New macro.  This properly takes care of exciting C
	type promotion rules to properly indicate errors.
	(get_swap_size, get_swap_free, get_swap_active): Replace definitions
	with ones using SWAP_FIELD macro.
	(ensure_def_pager_info): Give an error message for lack of a default
	pager; check only once.

1999-09-23  Mark Kettenis  <kettenis@gnu.org>

	* login.c (main): Pass controlling terminal ID port to the child.

1999-09-19  Roland McGrath  <roland@baalperazim.frob.com>

	* w.c (add_utmp_procs): Ignore entries whose ut_type is not
	LOGIN_PROCESS or USER_PROCESS, or whose ut_line is empty.

1999-08-10  Thomas Bushnell, BSG  <tb@mit.edu>

	* portinfo.c: Correct documentation for (currently implemented)
	--target-send and --target-send-once options.  Reported by Marcus
	Brinkmann (Marcus.Brinkmann@ruhr-uni-bochum.de).

1999-07-23  Roland McGrath  <roland@baalperazim.frob.com>

	* Makefile (targets): Remove freeauth, added accidentally.

1999-07-17  Roland McGrath  <roland@baalperazim.frob.com>

	* rpctrace.c (rewrite_right): If we see our own wrapper right,
	unwrap and replace it with the original send right.
	(trace_and_forward): Remove vm_map special case.

	* rpctrace.c: Mostly rewritten.  Now mostly working with skeletal
	functionality.

1999-07-15  Roland McGrath  <roland@baalperazim.frob.com>

	* rpctrace.c: New file, from josem and gord.  Not yet functional.
	* Makefile (rpctrace): New target.
	(targets): Add rpctrace.
	(SRCS): Add rpctrace.c.

1999-07-10  Roland McGrath  <roland@baalperazim.frob.com>

	* pids.c: Add #include <sys/mman.h> for munmap decl.
	* showtrans.c: Likewise.
	* login.c: Likewise.
	* storeread.c: Likewise.
	* msgport.c: Likewise.

1999-07-03  Thomas Bushnell, BSG  <tb@mit.edu>

	* login.c (cat): Use munmap instead of vm_deallocate.
	(check_owned): Likewise.
	(kill_login): Likewise.
	* storeread.c (main): Likewise.
	* showtrans.c (main): Likewise.
	* pids.c (add_fn_pids): Likewise.
	* msgport.c (cmd_getenv): Likewise.

1999-07-01  Mark Kettenis  <kettenis@gnu.org>

	* Makefile (INSTALL-addauth-ops, INSTALL-setauth-ops,
	INSTALL-su-ops): Removed.  These programs don't have to be
	installed suid-root anymore.
	* frobauth-mod.c (frobauth_modify): Do not try to set the owner of
	the processes we're frobbing.  The process set their owner
	themselves when we pass them their new authentication.

1999-06-21  Roland McGrath  <roland@baalperazim.frob.com>

	* login.c (main): For no-uids shell, default SH_ARG0 to informative
	value.  Use asprintf to construct it.

1999-06-20  Roland McGrath  <roland@baalperazim.frob.com>

	* ps.c (options): Doc fix.

1999-05-29  Roland McGrath  <roland@baalperazim.frob.com>

	* w.c (fetch_boot_time): New function.  Use libps to get
	task_basic_info for PID 1 (init); its creation_time is "boot time".
	(uptime): Use it, instead of stat'ing /var/run/uptime.

	* ps.c (output_fmts): Add %start and %time specs before %command
	in "user" (ps -u) format.

1999-05-16  Roland McGrath  <roland@baalperazim.frob.com>

	* portinfo.c (parse_task): Fail with appropriate error message if the
	fetched task is MACH_PORT_NULL.

1999-04-25  Roland McGrath  <roland@baalperazim.frob.com>

	* shd.c (run): Print child's PID when pausing before exec.

Fri Mar 12 15:22:02 1999  Thomas Bushnell, BSG  <tb@mit.edu>

	* login.c (add_utmp_entry): Properly call setutent and endutent
	around the getutline call.

1999-03-11  Roland McGrath  <roland@baalperazim.frob.com>

	* portinfo.c (main): Grok -E and inhibit error msg for
	print_xlated_port_info if set.
	(options): #if 0 -q option until we implement it.

1999-02-17  Roland McGrath  <roland@baalperazim.frob.com>

	* mount.sh: Use `awk' instead of `gawk'.

Fri Feb 19 02:43:11 1999  Thomas Bushnell, BSG  <tb@mit.edu>

	* login.c (main): Correctly implement -f instead of always
	acting as if it were set.

	* login.c (main): When transitioning from no UID's to having UID's
	create a new session like normal.  Reported by Mark M. Kettenis
	<kettenis@wins.uva.nl>.

1999-02-06  Mark Kettenis  <kettenis@gnu.org>

	* login.c (main): If no effective uid, really use first auxiliary
	uid to use as password entry to get parameters from.

1999-01-03  Roland McGrath  <roland@baalperazim.frob.com>

	* syncfs.c: Replace -a/--asynchronous with -s/--synchronous.
	Default is now asynchronous.

1998-12-31  Roland McGrath  <roland@baalperazim.frob.com>

	* Makefile (SRCS, targets, targets rule): Rename sync to syncfs.
	* syncfs.c: Renamed from sync.c.
	Take flags -a/--asynchronous and -c/--no-children,
	and optional file arguments.  Diagnose errors.

1998-10-20  Roland McGrath  <roland@baalperazim.frob.com>

	* Makefile (OBJS): Use % pattern instead of explicit list.

	* parse.c (parse_enum): Add braces to silence gcc warning.
	* psout.c (psout): Likewise.
	* settrans.c (main): Likewise.
	* showtrans.c (main): Likewise.
	* w.c (w_fetch): Likewise.
	* vminfo.c (main): Likewise.

1998-09-05  Roland McGrath  <roland@baalperazim.frob.com>

	* ping.c: <linux/icmp.h> -> <netinet/ip_icmp.h>;
	struct icmphdr -> struct icmp;
	Remove macro hacks to cope with old headers.
	(pinger_wrapper): Take and return void *, so we're a cthread_fn_t.

1998-09-04  Roland McGrath  <roland@baalperazim.frob.com>

	* portinfo.c (hold): Declare explicit `int' to silence warning.

	* Makefile (OBJS): Use pattern %.sh instead of explicit list.

Fri Aug 21 19:25:12 1998  Jose M. Moya  <josem@gnu.org>

	* msgport.c: Comments added.
	(add_cmd): cmd_add renamed to add_cmd.
	(parse_cmd_opt): cmd_parse_opt renamed to parse_cmd_opt.

Mon Aug  3 17:10:05 1998  Joel N. Weber II  <devnull@theobromine.ai.mit.edu>

	* Makefile (msgport): Add dependency on libshouldbeinlibc.

1998-07-25  Jose M. Moya  <josem@gnu.org>

	* msgport.c: Fixed to deallocate ports.

1998-07-24  Jose M. Moya  <josem@gnu.org>

	* msgport.c: New file.
	* Makefile (targets): Add `msgport'.
	(SRCS): Add `msgport.c'.
	(msgport): Add dependencies on parse.o and pids.o.

1998-07-20  Roland McGrath  <roland@baalperazim.frob.com>

	* ps.c (main): Fix return type to int, and use return.
	* ids.c (main): Likewise.
	* w.c (main): Likewise.
	* login.c (main): Likewise.
	* settrans.c (main): Likewise.
	* showtrans.c (main): Likewise.
	* fsysopts.c (main): Likewise.
	* storeinfo.c (main): Likewise.
	* unsu.c (main): Likewise.
	* setauth.c (main): Likewise.
	* rmauth.c (main): Likewise.
	* addauth.c (main): Likewise.

	* w.c (main): Avoid warning from `while (a = b)'.

Wed Apr 22 16:38:59 1998  Thomas Bushnell, n/BSG  <tb@mit.edu>

	* ping.c (MAXHOSTNAMELEN): Don't define.
	(main): Delete variable `hnamebuf'.  Store directly into properly
	malloced `hostname' variable.

Wed Apr 22 16:29:18 1998  Thomas Bushnell, n/BSG  <tb@mit.edu>

	* ping.c: New file.  Originally P.D. from US Army; then modified
	by BSD, then added to Linux.  Taken from Linux ping and adapted
	for Hurd and submitted for inclusion by Kunihiro Ishiguro
	(kunihiro@zebra.org).
	* Makefile (targets): Add `ping'.
	(SRCS): Add `ping.c'.
	(ping-CPPFLAGS): New variable, to find <linux/icmp.h> in the
	pfinet sources.
	(INSTALL-ping-ops): Install ping suid root.
	(ping): Depend on `../libthreads/libthreads.a'.

1997-09-29  Miles Bader  <miles@gnu.ai.mit.edu>

	* unsu.c (argp_program_version): Use correct program name.

1997-09-26  Miles Bader  <miles@gnu.ai.mit.edu>

	* frobauth-mod.c (frobauth_modify): Add AUTHS & NUM_AUTHS parameters.
	* frobauth.h (frobauth_modify): Add AUTHS & NUM_AUTHS parameters.
	* rmauth.c (main): Supply new args to frobauth_modify.
	* unsu.c (main): Likewise.
	* setauth.c (main): Likewise.
	* login.c (main): Use ugids_verify_make_auth instead of
	ugids_verify and ugids_make_auth.
	* addauth.c (main): Likewise.
	* setauth.c (main): Likewise.

	* w.c (main): Remove DEFAULT_OUTPUT variable.

1997-08-08  Miles Bader  <miles@gnu.ai.mit.edu>

	* ftpcp.c (eappend, ebasename): New functions.
	(append_basename): New function.
	(main): Move target directory handling to append_basename.
	Use it also with remote transfers.

	* ftpcp.c (cntl_debug): Print CONN->hook as a string before any output.
	(main): Set the connection hooks to appropriate strings.
	(econnect): Add NAME parameter, & set connection hook from it.

1997-07-29  Miles Bader  <miles@gnu.ai.mit.edu>

	* ftpcp.c (main): When mungeing the destination to copy into a
	directory, do the name used to print error messages too.

1997-07-15  Miles Bader  <miles@gnu.ai.mit.edu>

	* vmstat.c (ensure_def_pager_info): Don't report any errors if
	there's no default pager.

1997-07-10  Miles Bader  <miles@gnu.ai.mit.edu>

	* vmstat.c (main): Don't print fields we cannot get.

1997-07-03  Miles Bader  <miles@gnu.ai.mit.edu>

	* ftpdir.c (main): Flush stdout after printing prefix/separator.

1997-06-19  Miles Bader  <miles@gnu.ai.mit.edu>

	* storecat.c, storeread.c: Moved here from ../libstore.
	* Makefile (SRCS): Add storecat.c & storeread.c.
	(targets): Add storecat & storeread.
	Add storecat & storeread to appropriate dependency rules.

1997-06-13  Miles Bader  <miles@gnu.ai.mit.edu>

	* settrans.c (main): Print the translated-node name instead of the
	translator name if the translator startup error is due to opening it.

1997-06-10  Miles Bader  <miles@gnu.ai.mit.edu>

	* ids.c (argp_program_version): Change name to `ids'.

Mon Jun  9 12:45:24 1997  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>

	* Makefile (SRCS): Add setauth.c, pids.c, unsu.c, and nonsugid.c.

Wed Jun  4 14:26:53 1997  Miles Bader  <miles@gnu.ai.mit.edu>

	* ftpcp.c, ftpdir.c: Files moved from ../libftpconn.
	* Makefile (HURDLIBS): Add ftpconn.
	(ftpcp ftpdir): Add dependency on ../liftpconn/libftpconn.a.
	(SRCS): Add ftpcp.c & ftpdir.c.
	(targets): Add ftpcp & ftpdir.

Tue May 27 14:55:30 1997  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (args_doc): Variable removed.
	(main): Don't use ARGS_DOC.
	Correct filtering of process-owners when processes are explicitly
	specified.

Mon May 26 02:21:19 1997  Miles Bader  <miles@gnu.ai.mit.edu>

	* su.c, addauth.c: Totally rewritten.
	* rmauth.c, setauth.c, unsu.c, frobauth.h, frobauth.c,
	frobauth-mod.c, nonsugid.c, pids.c, pids.h: New files.
	* Makefile: Add appropriate dependencies on parse.o, pids.o,
	frobauth.o, & frobauth-mod.o.
	(addauth-LDLIBS, setauth-LDLIBS, su-LDLIBS): New variables.

	* ids.c: Renamed from hurdids.c.
	* Makefile (targets): hurdids renamed to ids.
	(SRCS): hurdids.c renamed to ids.c.
	(INSTALL-ids-ops): Renamed from INSTALL-hurdids-ops.

	* login.c (child_argps): New variable.
	(options): Remove uid/gid args.
	(main): Use ugids operations instead of doing [ug]id frobbing
	ourselves.
	<ugids.h>: New include.

	* ps.c (options): Rearranged to group similar options.
	Process-selection options removed.
	(current_lid, current_sid): Functions removed.
	(lookup_user): Take new STATE argument.
	(main): Use PIDS_ARGP to select processes.
	Use new forms of parse_ functions.
	"pids.h": New include.

Tue May 20 14:38:22 1997  Miles Bader  <miles@gnu.ai.mit.edu>

	* parse.c (parse_enum, parse_numlist, parse_strlist, _parse_strlist):
	Change void * HOOK parameters to struct argp_state *STATE.
	* parse.h (parse_enum, parse_numlist, parse_strlist): Likewise.

Mon May 19 23:04:54 1997  Miles Bader  <miles@gnu.ai.mit.edu>

	* parse.c (parse_enum, parse_numlist, parse_strlist, _parse_strlist):
	Add HOOK argument, and pass it to callback functions.
	* parse.h (parse_enum, parse_numlist, parse_strlist): Likewise.

Thu May 15 14:04:29 1997  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (procset_names, fmt_sortkeys, fmt_names, fmts): Variables
	removed.
	(enum procsets): Type removed.
	(struct output_fmt): New type.
	(output_fmt): New variable.
	(parse_enum): Function removed.
	(main): Use new version of parse_enum & output_fmts variable.

	* login.c, addauth.c (main: verify_passwd): Make
	user-in-group-0-can-use-his-own-password-to-su work.

	* parse.c, parse.h: New files.
	* addauth.c: Replace include of "psout.h" with one of "parse.h".
	(_parse_strlist, parse_numlist): Functions removed.
	* ps.c: Include "parse.h".
	(_parse_strlist, parse_strlist, parse_numlist): Functions removed.
	* Makefile (SRCS): Add parse.c.
	(LCLHDRS): Add parse.h.
	Add dependencies on parse.o.

	* addauth.c: Renamed from addu.c.
	* Makefile: Change references to addu into ones to addauth.

Fri Apr 25 13:06:29 1997  Miles Bader  <miles@gnu.ai.mit.edu>

	* hurdids.c (main): Use the parent process's auth port instead of
 	the hurdids process's, because hurdids is usually installed setuid.

	* login.c, addu.c (main: verify_passwd): Add
	user-in-group-0-can-use-his-own-password-to-su hack.

Wed Apr 16 15:59:41 1997  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>

	* login.c (add_utmp_entry): Revert change of December 10, 1996.

Fri Mar  7 11:53:02 1997  Miles Bader  <miles@gnu.ai.mit.edu>

	* addu.c: New file.
	* Makefile: Add addu to dependents of libshouldbeinlibc & libps.
	(INSTALL-hurdids-ops, INSTALL-addu-ops): New variables.
	(SRCS): Add addu.c.
	(targets): Add addu.

	* hurdids.c (args_doc): Initialize with "[PID]".
	(main): Get the ids from the auth port instead of using libc grot.
	Support getting ids from other processes.

Sat Mar  1 21:27:03 1997  Miles Bader  <miles@gnu.ai.mit.edu>

	* w.c (add_utmp_procs): Ignore unused utmp entries.
	(main): Support USER... args.

Wed Feb 26 17:47:04 1997  Miles Bader  <miles@gnu.ai.mit.edu>

	* devprobe.c (main): Fetch DEVICE_MASTER *before* we use it.
	Use argp_failure instead of error.
	Open device read-only.

Wed Feb 19 22:16:40 1997  Miles Bader  <miles@gnu.ai.mit.edu>

	* fsysopts.c, hurdids.c, login.c, portinfo.c, ps.c, settrans.c,
 	showtrans.c, storeinfo.c, sync.c, vminfo.c, vmstat.c, w.c
 	(argp_program_version): Make const.

	* devprobe.c (main): Parse arguments before getting device master port.

Tue Feb 11 20:51:51 1997  Miles Bader  <miles@gnu.ai.mit.edu>

	* settrans.c (options): Update to reflect some minor changes in
	the way argp works.

Thu Feb  6 01:40:19 1997  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (main): Look for NOBODY in ARGS_DEFS too, and use a last
	ditch default if we can't find it anywhere.
	Deal with crypt failing.

	* w.c (w_get_host): Don't use strlen on it if *HOST is 0.

Mon Dec 16 20:52:19 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* psout.c (psout): Use last N processes if TOP is negative.
	* ps.c (options): Update doc for --top.
	Add --head and --bottom/--tail/-b options.
	(main): Implement --bottom/--tail/-b.

Tue Dec 10 11:40:04 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>

	* login.c (add_utmp_entry): ut_addr has changed to be an array;
	stash the IP address in the first slot.

Sat Nov 23 16:30:16 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>

	* psout.c (psout): Delete var REMOVE.

Fri Nov 15 19:05:46 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* w.c (read_utmp_procs): Function removed.
	(main): Use utmp.h functions for reading utmp.

Thu Oct 24 15:00:49 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* vmstat.c (options): Remove header for run-time supplied fields.
	(main): And add it back here as a child header.

Wed Oct 23 14:04:47 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* vmstat.c (main): Replace PARENTS with CHILDREN, which uses the
	new argp_child structure.

Thu Oct 10 13:53:23 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (options, main): Add --top/-h option.
	* psout.c (psout): Add TOP parameter.
	* psout.h (psout): Add TOP parameter.
	* w.c (main): Supply new TOP arg to psout.

Wed Oct  9 14:24:54 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* w.c (w_fetch): Use tty st_atime for idle time.

	* w.c (_w_specs): Use ps_cmp_unames for `Name'.
	Use ps_nominal_string for `Name' and `From'.
	(ps_cmp_unames, ps_nominal_string): New declarations.
	(DEFAULT_FMT_STRING): Add %pid.

Tue Oct  8 14:44:04 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* storeinfo.c (print_store): Properly ignore STORE_INACTIVE.

	* w.c (w_fetch): Set HAVE bits even if the values are `nominal'.
	Correctly propagate PS->inapp bits.
	(_w_specs): Add PS_FMT_FIELD_COLON_MOD to Idle's flags.
	(main): Initialize dependencies field of USER_HOOKS to w_deps.
	(w_deps): New function.

	* storeinfo.c (print_store): Correctly print unknown flags.
	Don't ever print STORE_INACTIVE flag.

Mon Oct  7 15:48:23 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* storeinfo.c (main): Use STORE_INACTIVE flag to store_create.

Thu Oct  3 16:08:21 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* vmstat.c (name_to_option): Correct test for malloc failure.
	(get_memobj_hit_ratio): Renamed from get_cache_hit_ratio.
	(fields): Add `max' field.
	Rename `cache *' fields to `memobj *', and reword doc strings.
	(val_width): New function.
	(main): Calculate verbose output widths differently.
	(main: FWIDTH): New macro.
	(VAL_MAX_MEM, VAL_MAX_SWAP, K, M, G): New macros.

Wed Oct  2 10:24:04 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* vmstat.c (struct field): Remove desc field, add doc field.
	(fields): Initialize doc field, and not desc.
	(name_to_option): New function.
	(main): Rearrange use of name, doc, and desc fields in struct field.

	* sush.sh: Handle `-' and `--' args properly.

Fri Sep 27 13:01:31 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* storeinfo.c (options, main): Change --runs/-r to --block-list/-l.
	(print_store): Print runs in grub block-list format.

Fri Sep 27 01:07:20 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* storeinfo.c (options, main): Change --kind/-k to --type/-t.
	Add --flags/-f option.
	(W_TYPE): Renamed from W_KIND; all uses changed.
	(W_FLAGS): New macro.
	(print_store): Print flags separately from type.
	(doc): Updated.

Thu Sep 26 16:10:03 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* Makefile (%: %.sh): Rule removed.

Tue Sep 24 17:05:08 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (main: verify_passwd): Only declare reference to crypt
	weak if HAVE_CRYPT isn't defined.

	* sush.sh: Fix option parsing.

Mon Sep 23 00:19:05 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* sush.sh, uptime.sh: Add option parsing, version number, &c.
	Add copyright notice.

	* Makefile (login-LDLIBS): Add $(LIBCRYPT).

Thu Sep 12 16:37:42 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>

	* Makefile (HURDLIBS): New variable.

Thu Sep  5 11:45:58 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>

	* Makefile: Use $(top_srcdir)/sh-version.h to make executables
 	from .sh files.

	* fsysopts.c: Include <version.h>.
	(argp_program_version): Define with STANDARD_HURD_VERSION.
	* w.c: Likewise.
	* vmstat.c: Likewise.
	* vminfo.c: Likewise.
	* sync.c: Likewise.
	* storeinfo.c: Likewise.
	* showtrans.c: Likewise.
	* settrans.c: Likewise.
	* ps.c: Likewise.
	* portinfo.c: Likewise.
	* login.c: Likewise.
	* hurdids.c: Likewise.

Sun Sep  1 14:15:46 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* sync.c (argp_program_version): New variable.
	(main): Call argp_parse with just a doc string.
	<argp.h>: New include.
	* Makefile (sync): Depend on libshouldbeinlibc.a.

Fri Aug 30 16:54:57 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* vminfo.c: New file.
	* Makefile (targets): Add vminfo.
	(SRCS): Add vminfo.c.
	(INSTALL-vminfo-ops): New variable.

Mon Aug 19 15:19:20 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* devprobe.c, fsysopts.c, hurdids.c, login.c, portinfo.c, ps.c,
 	settrans.c, showtrans.c, storeinfo.c, vmstat.c, w.c, x.c (doc):
 	Add program description.

Wed Aug 14 10:18:41 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* Makefile (login-LDLIBS): New variable.
	(login): Dependency on -lutil removed.
	(libutil-libsubst): Variable removed.

Sat Aug 10 10:03:57 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (options): Whoops, short option for --sort is -s.

	* Makefile (LCLHDRS): New variable.

Wed Jul 31 14:23:31 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (main/verify_passwd): Use #pragma weak instead of
	__attribute__ ((weak)).
	* su.c (check_password): Likewise.

	* login.c (options): Change --inherit-environ to --preserve-environment.
	Change --no-environ to --no-environment-args.
	Change --environ to --envvar and --environ-default to --envvar-default.
	* ps.c (options, main): Change --fmt to --format/-F.
	Change --posix-fmt/-o to --posix-format/-o.
	Change --sort to --sort/-s.
	Change --pgrp to --pgrp/-G.
	Change --login to --login/-L.
	Change --threads/-s to --threads/-T.
	Change --session to --session/-S.
	(OPT_FMT, OPT_SORT, OPT_PGRP, OPT_LOGIN, OPT_SESS): Macros removed.
	* w.c (options, main): Change --fmt to --format/-F.
	Change --sort to --sort/-s.
	(OPT_FMT, OPT_SORT): Macros removed.

Wed Jul 31 14:24:05 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>

	* login.c (main/verify_passwd): Declare crypt weak in a portable
	way.
	* su.c (check_password): Likewise.

Tue Jul 30 14:49:48 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>

	* login.c (main/verify_passwd): If government is broken, don't use
	crypt.
	* su.c (check_password): Likewise.

	* login.c (main/verify_passwd): Provide correct prototype for
	crypt.
	* su.c (check_password): Likewise.

Mon Jul 29 03:22:07 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* vmstat.c (val_t): Make `long long'.

Sun Jul 28 21:13:31 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* w.c (main): Correctly parse the -w/--width option.

Fri Jul 26 12:34:00 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* vmstat.c (enum val_display_type): Add `PAGESZ'.
	`SIZES' -> `SIZE'; all uses updated.  Remove BYTES, PAGES, and KBYTES.
	(fields): disp_type of "pagesize" and "swap-pagesize" changed to PAGESZ.
	(val_display_type_is_size): Function removed.
	(struct field): `disp_type' field -> `type'; all used updated.
	(print_val): Add TYPE & SIZE_UNITS arguments; remove HOW & PSIZE.
	(main): Variable user_disp_type removed.  Variable size_units added.
	Add SIZE_UNITS macro, remove FDISPTYPE macro.
	Calls to print_val now use new PVAL macro.
	(get_vmstats_field): Just test against a type of SIZE, instead of
	using val_display_type_is_size.

Thu Jul 25 22:36:38 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* Makefile (INSTALL-vmstat-ops): New variable.

	* vmstat.c (options, main): -k/--kilobytes, -v/--pages, and
	-b/--bytes options added.
	(fields): New struct members initialized.  `size',
	`cache-hit-ratio', `swap-size', `swap-active', `swap-free', and
	`swap-pagesize' added.
	(val_t, enum val_display_type, enum field_change_type): New types.
	(val_display_type_is_size, print_val, vm_state_refresh,
	vm_state_get_field, get_vmstats_field, get_size,
	ensure_def_pager_info, get_swap_size, get_swap_free,
	get_swap_page_size, get_swap_active): New functions.
	(struct field): CHANGE_TYPE, DISP_TYPE, STANDARD, and COMPUTE
	fields added.  CUM field removed.
	(struct vm_state): New type.
	(main): Changed greatly to use vm_state type & functions, use
 	print_val, and support CONST display types nicely.
	(argp_program_version): Version changed to 1.1.

Sun Jul 21 03:00:10 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* fsysopts.c (main): Print an error for no args.
	* portinfo.c (main): For no args, use argp_usage.
	(options): Minor fixes.

Sat Jul 20 15:54:10 1996  Michael I. Bushnell, p/BSG  <mib@gnu.ai.mit.edu>

	* Makefile (DIST_FILES): Deleted var (which was `shd.ChangeLog').
	(shd.ChangeLog): Deleted file.

Fri Jul 19 21:09:57 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* settrans.c (options): Rearrange slightly.

Tue Jul 16 21:38:01 1996  Michael I. Bushnell, p/BSG  <mib@gnu.ai.mit.edu>

	* login.c (main): If chown fails, print error message using errno,
 	not -1.

Fri Jul 12 15:49:09 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (dog): Get rid of `Beware of dog' -- it can't ever happen.
	Rename watch_login calls to check_login; don't use return value.
	(check_login): Renamed from watch_login.  Change type to void.
	Exit if there's no such process.

	* login.c (main): Only start a watchdog timer if in a new login coll.

	* login.c (watch_login): New function.
	(dog): Use watch_login.  Get rid of wierd rules for root-gone-away.

	* Makefile (INSTALL-ps-ops, INSTALL-w-ops): New variables.

Fri Jul 12 14:20:44 1996  Michael I. Bushnell, p/BSG  <mib@gnu.ai.mit.edu>

	* Makefile (INSTALL-login-ops): New variable.

Sun Jul  7 21:31:36 1996  Michael I. Bushnell, p/BSG  <mib@gnu.ai.mit.edu>

	* settrans.c (main): Don't use unsafe MOVE_SEND in call to
 	file_set_translator.

Sat Jul  6 18:06:52 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* portinfo.c, vmstat.c, hurdids.c, fsysopts.c, settrans.c,
	showtrans.c, storeinfo.c, login.c, w.c, ps.c
	(argp_program_version): New variable.
	* vmstat.c <hurd.h>: New include.

Fri Jul  5 22:28:11 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (add_utmp_entry): Pass the the basename of TTY to getutline.

Wed Jul  3 14:00:08 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (add_utmp_entry): Don't fill in ut_line or ut_type
	fields in UTMP.
	Fill in the ut_addr field.

	* Makefile (settrans): Depend on ../libports/libports.a.

Tue Jul  2 14:54:43 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (dog): Include all args in the asprintf.
	Put the ARGV message in parens.

Mon Jul  1 13:05:53 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (kill_login): Don't kill dog.
	(dog): Take new ARGV argument, and record status in it for ps.
	(main): Pass ARGV to dog.

	* w.c (_w_specs): Don't use utmp buffer sizes for field widths, as
	they can be very large.

	* login.c (add_utmp_entry): Always fill in UTMP.ut_line.
	Set UTMP.ut_type.

Fri Jun 28 15:44:15 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (add_utmp_entry): Increment TTY_FD while searching for a
	TTY.

Mon Jun 24 16:02:04 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (main): Fix heuristic to decide whether native booted.

Thu Jun 20 14:41:25 1996  Michael I. Bushnell, p/BSG  <mib@gnu.ai.mit.edu>

	* login.c (main): No need for EXEC_NEWTASK or EXEC_SECURE.

	* Makefile (getty): Remove rule.
	(targets): Remove `getty'.
	(SRCS): Remove getty.c.
	* getty.c: Removed file to daemons directory.

Wed Jun 19 14:11:14 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (hurd_file_name_path_lookup): Declaration removed.
	(main: child_lookup): Pass 0 for new LOOKUP arg to
	hurd_file_name_path_lookup.

Mon Jun 17 18:06:03 1996  Michael I. Bushnell, p/BSG  <mib@gnu.ai.mit.edu>

	* Makefile (targets): Add `getty'.
	(SRCS): Add `getty.c'.
	(getty): Depend on -lutil.

Mon Jun 17 10:41:28 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* Makefile (targets): Remove reboot & halt.
	(SRCS): Remove reboot.c & halt.c.
	(login): Depend on -lutil instead of grot.

Tue Jun 11 13:43:18 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (get_utmp_host): Function removed.
	(add_utmp_entry): Get rid of TTY_FD parameter.  Don't search for
	the tty unless we need it to get the old host, since login does it
	for us.
	Also use the `existing host' in the case that a new one isn't specified.
	(main): Update call to add_utmp_entry.

	* login.c (dog): Don't print stupid message if login session is empty.
	(add_utmp_entry): Use gettimeofday instead of time to get the time.

Wed May 29 11:01:18 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* sush.sh: Don't use -z flag to login.

Tue May 28 17:48:12 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (main): Fetch the parent uids before checking their number.
	(dog): Don't kill session if the user logged in!
	Print newline before message.
	(check_owned): Return OWNED, not NOTOWNED.

	* ps.c (fmts): Use %sz for vmem format, not %size.
	(spec_abbrevs): Still use `NTH' for field name, just `TH' for title.
	(fmts): Use %nth.

Tue May 21 12:18:38 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* storeinfo.c (print_store): Get rid of class-name printing code,
	and use store->class->name.  Print all flags.

Tue May 14 09:50:21 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (dog): Use error to print messages.  Use pretty time fmting.
	(main): Fork login timeout watchdog before clearing the process owner.

	* login.c (main): Only allow real users to make new login collections.

Mon May 13 18:10:43 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (options, main): Remove -z/--no-utmp option.
	(main): Only add utmp entry for session leader.
	Clear process owner if no uids.
	Fork self-destruct timer when appropiate.
	(default_args): Add NOAUTH_TIMEOUT entry.
	(check_owned, kill_login, dog): New functions.

Sun May 12 13:38:34 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* psout.c (psout): When printing result of ps_fmt_creation_error,
 	don't pass ERR to error (it should already be in PROBLEM if necessary).

Sat May 11 01:00:39 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (_parse_strlist, parse_strlist, parse_numlist, lookup_user,
	main):  Slather on consts, in a misguided attempt to shut up the
	compiler.

Fri May 10 13:53:30 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* devprobe.c (parse_opt): Use ARGP_ERR_UNKNOWN instead of EINVAL.
	* showtrans.c (parse_opt): Likewise.
	* portinfo.c (parse_opt): Likewise.
	* ps.c (parse_opt): Likewise.
	* settrans.c (parse_opt): Likewise.
	* login.c (parse_opt): Likewise.
	* hurdids.c (parse_opt): Likewise.
	* fsysopts.c (parse_opt): Likewise.

	* showtrans.c (parse_opt): Print a usage msg with no args.
	(options, main): Add --translated/-t option.

	* Makefile (storeinfo): Depend on ../libstore/libstore.a.

	* settrans.c (main): Remove const cast from first arg to argz_create.
	* fsysopts.c (main): Likewise.
	* login.c (main): Likewise.
	(main): Remove const from decl of USER & ARG.
	(fail): Remove const from decl of VIA.

	* ps.c (parse_strlist): Make DEFAULT_FN return a const char *.

	* storeinfo.c (print_store): New function.
	(info): Use store_create to make a store and print_store to print it.
	(parse_opt): Print a usage message for no args.
	(options, parse_opt): Add --children option.

Thu May  9 19:46:14 1996  Michael I. Bushnell, p/BSG  <mib@gnu.ai.mit.edu>

	* w.c (uptime): Cast arg to localtime appropriately.

	* login.c (add_utmp_entry): Declare HOST `char const *'.
	(main) [fail]: Declare VIA `char const *'.
	(main): Declare USER `char const *'.
	Declare ARG `char const *'.

	* login.c (main): Provide new third arg to proc_setowner.

	* fsysopts.c (main) [parse_opt]: Cast first arg of argz_create
 	appropriately.
	* settrans.c (main) [parse_opt]: Likewise.
	* login.c (main) [parse_opt] [case ARGP_KEY_ARG]: Likewise.
	(main): Likewise.

	* ps.c (main) [current_tty_name]: Remove `const' keyword to avoid
 	type clash.

	* ps.c (main) [proc_stat_has_ctty]: Add parentheses around
 	assignment used as truth value.

Mon May  6 17:36:22 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* psout.c (psout): Take a field, not a spec.  Honor PS_FMT_FIELD_KEEP.

	* w.c (w_user_getter): New function.
	(w_get_user): New function.
	(w_fetch): Implement W_PSTAT_USER.
	(struct w_hook): Add user field.
	(_w_specs): Add "Name" entry.
	(w_get_uname): Renamed from w_get_user.
	(w_uname_getter): Renamed from w_user_getter.
	* ps.c (fmts): Upcase most format strings.

Sun May  5 01:05:54 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* psout.h: New file.
	* ps.c (fmts): Use new field syntax.
	(options): Add -o/--posix-fmt option.  -A is an alias.
	"psout.h": New include.
	* w.c (_w_specs): Add precision & keep fields.
	(DEFAULT_FMT_STRING): Use new field syntax.
	"psout.h": New include.
	(main): Update call to psout.
	* psout.c (psout): Add posix_fmt arg.

Thu May  2 00:10:53 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* psout.c (psout): Use ps_fmt_creation_error to find out in detail
	why ps_fmt_create fails.

Wed May  1 19:53:51 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* settrans.c (main): Default KILL_ACTIVE to 0.

Tue Apr 30 19:04:01 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* w.c (_w_specs): Use ps_emit_past_time to show login times.

Tue Apr 30 09:47:03 1996  Michael I. Bushnell, p/BSG  <mib@gnu.ai.mit.edu>

	* Makefile (all): Remove target.
	(include ../Makeconf): Place before all dependencies.
	($(targets)): Each separate target should depend on its own .o.

Tue Apr 23 13:49:36 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (main): Try to intuit whether this is a native-booted hurd
	system, and if so, don't filtered out non-parented processes.

Wed Apr 10 19:47:45 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* devprobe.c: New file.
	* Makefile (targets): Add devprobe.
	(SRCS): Add devprobe.c.

Mon Apr  8 17:09:55 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* portinfo.c (options, doc): Change meaning of --translate's
	argument, in preparation for other changes.
	(options, main): Add, but don't really implement, --search option.

Fri Mar 29 14:37:49 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* settrans.c (options): Add --exclusive option, change descriptions.
	(main): Rearrange meanings of arguments somewhat.

Thu Mar 28 13:58:36 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* portinfo.c (main): Use new names for functions, and pass stdout.
	(port_info, ports_info, xlated_port_info, xlated_ports_info,
	name_xlator_create, name_xlator_free, name_xlator_xlate):
	Functions removed (renamed and put in libshouldbeinlibc).

	* portinfo.c (parse_task): Use strtoul instead of atoi so pid 0 works.

Mon Mar 25 14:19:40 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* w.c (uptime): Correctly calculate uptime.
	(...various...): Use real types instead of old ps typedefs.
	* ps.c (spec_abbrevs): Make const.
	(ps_specs): Make non-const.
	(...various...): Use real types instead of old ps typedefs.
	* psout.c (psout): Use real types instead of old ps typedefs.

Sat Mar 23 01:02:37 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* w.c (uptime): Add a temporary hack to pretend to show uptime.

Mon Mar 18 18:34:51 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (main): Pass new arg to argp_parse.
	* w.c (main): Likewise.
	* storeinfo.c (main): Likewise.
	* fsysopts.c (main): Likewise.
	* hurdids.c (main): Likewise.
	* login.c (main): Likewise.
	* vmstat.c (main): Likewise.
	* showtrans.c (main): Likewise.
	* settrans.c (main): Likewise.  Also use argp_usage correctly.
	* portinfo.c (main): Likewise.

Tue Mar  5 14:17:22 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* portinfo.c (main): Fix arg order to name_xlator_create.
	(name_xlator_create): Return X in XLATOR.
	(name_xlator_free): Deallocate all ports in X too.
	(main): Use xlated_port_info / xlated_ports_info.
	(xlated_port_info, xlated_ports_info): New functions.
	(struct name_xlator, name_xlator_create, name_xlator_xlate): Don't
	depend on a specified receive/send type for the source being specified.
	(name_xlator_xlate): Take FROM_TYPE arg, & return TO_TYPE.
	(options, main): Get rid of -R/-S options, and add --translate/-t
	option.

Mon Mar  4 15:25:41 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* portinfo.c (struct name_xlator): New structure.
	(name_xlator_create, name_xlator_free, name_xlator_xlate): New funcs.
	(options, main): Add --translate-{receive,send}/-R/-S options.

Fri Mar  1 18:55:07 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* Makefile (targets, SRCS): Add portinfo & portinfo.c.

Tue Feb 27 14:51:16 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* Makefile (targets, SRCS): Remove clri & clri.c.

Mon Feb 26 13:50:38 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* settrans.c (main): Don't print a newline after `Pausing...' msg.

	* ps.c: Include <error.h> instead of "error.h".
	"common.h": Don't include this anymore.

Wed Feb 21 11:47:01 1996  Roland McGrath  <roland@charlie-brown.gnu.ai.mit.edu>

	* w.c (uptime): Use %.2f format for load average numbers.

Mon Feb 19 15:49:46 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* settrans.c (STRINGIFY): Make work.  Is this in a header somewhere?
	(_STRINGIFY): New macro.  Ick.

	* fsysopts.c (main): Use ARGP_IN_ORDER.

Sat Feb 17 23:47:36 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* uptime.sh: New file.
	* Makefile (targets, special-targets): Add uptime.
	(SRCS): Add uptime.sh.

Thu Feb 15 15:47:45 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (main): Don't make -a imply -g.

	* sush.sh: Change -aBACKUP_SHELL to -aBACKUP_SHELLS.

	* login.c (child_lookup): Pass last arg to hurd_file_name_path_lookup.

Wed Feb 14 17:38:31 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* w.c (add_utmp_procs): Correctly add terminal processes using new
	libps functionality.
	(read_utmp_procs): Emit all utmp entries, even the last one.

	* ps.c (main): Get rid of totally dead processes/threads.
	(add_pid): Complain about non-existant processes.
	(psout): New declaration.

	* ps.c (parse_numlist): Correctly handle NULL hook functions.
	(parse_opt): Deref STATE correctly.
	(main): Update calls to changed proc_stat_list_add_* functions.

	* login.c (main): Don't set old SAW_USER_ARG variable.

Tue Feb 13 13:54:03 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* sush.sh: Exec login.

	* login.c (main): Deal with the shell args reasonably.

	* ps.c (parse_opt): Don't turn quoted args into options.

Mon Feb 12 14:54:38 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* settrans.c (options, main): Add --timeout/-t option.
	(main): Pass ARGP_IN_ORDER to argp_parse (it's no longer the
	default), and deal with the fallout.

Wed Feb  7 23:11:10 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (main): Allow switches in the login args naturally.

Mon Feb  5 14:18:03 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* vmstat.c (main, args_doc, doc): Add repeat mode.
	(FVAL): New macro.

	* vmstat.c (main): Slightly decrease the space for numbers in the
	verbose output format.
	Twiddle the widths of the terse fields to make sure there's room
	for typical numbers.

Sat Feb  3 01:28:20 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* vmstat.c (fields, options): Make const.

	* vmstat.c: New file.
	* Makefile (targets): Add vmstat.
	(SRCS): Add vmstat.c

	* login.c (main): Correctly add gids.
	Avoid duplicating the old real id when keeping the old ids.
	Don't ask for a password unnecessarily.

Thu Feb  1 19:15:53 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* sush.sh: Don't save the parent ids.

	* login.c (main): When the user is specified as the first
	argument, always add it as both effective, real, and saved ids,
	even if there are others already.

	* login.c (main): Get the ttyname to chown.
	Only do the chown if NO_LOGIN isn't set.

	* settrans.c (options, main): Add --pause option.

Thu Feb  1 16:27:24 1996  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* login.c (main): Chown the terminal.

Tue Jan 30 15:25:23 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (main): Put LOGNAME in the environ even if it was already.
	(copied_args): Add "USER".

Mon Jan 29 09:52:08 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (add_utmp_entry): Get rid of declaration for login().
	(main, default_args): Replace the BACKUP_SHELL param with
	BACKUP_SHELLS, which is a list of things to try.  The default
	includes both bash and the /bin/sh.
	(main): Try to set the default path using confstr().

Mon Jan 15 12:29:49 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* settrans.c (options, main): Make -g/--goaway only apply to
	active translators.
	(options): Rearrange a bit.

Sun Jan 14 12:45:40 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (main): Call setlogin().

Thu Jan 11 19:30:27 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (options, main): Change the -R/--retry option so that
 	the optional argument is an argument to add to those passed to
 	login when retrying, and remove all the hardwired arguments
 	(except propagating -h/--via).
	(default_args, options, main): Get rid of the -n/--nobody option
	and variables, making it an additional login parameter.

	* login.c (default_args): Make the default shell /bin/bash instead of
	_PATH_BSHELL.
	(default_args, default_env): Make the default path just /bin.

	* loginpr.sh (user): Pass the appropiate -R options to login.

Wed Jan 10 15:32:19 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (main): Turn on RETRY when the -h option is specified.

Fri Jan  5 15:21:36 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (add_canonical_host): Try harder to get the actual host name.

Thu Jan  4 22:37:46 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (add_canonical_host): New function.
	(add_utmp_entry): Use VIA_ADDR instead of VIA in the utmp entry if
	it fits better.
	(add_entry): Function moved out of main.
	(main): Use add_canonical_host() to implement the -h option.  Only
	let root specify the login host.

	* login.c (main): child_lookup() now takes an additional PATH arg,
	and calls hurd_file_name_path_lookup() instead.  Pass a path when
	looking up the shell executable.

Tue Jan  2 01:15:13 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* sush.sh: Instead of giving --su to login, use all the component
 	options it stood for.  Also use --program-name for nice errors.

	* login.c (main): Do all file-name lookups using the target
	authentication, so that login isn't a security hole.
	Rework how password-checking is done somewhat (only ask when necess).
	Call exec_reauth() with SECURE==0 so that it reauths all the ports.
	If setting the real [ug]id, also add it as the `saved id'.
	(cat): Take an io_t port instead of a file descriptor.
	(options, main): Get rid of the -s/--su option, and add -S/--shell-arg.
	(FAILURE_SHELL): Macro deleted.
	(default_args): Add BACKUP_SHELL param.
	(main): Use BACKUP_SHELL instead of FAILURE_SHELL define.

Mon Jan  1 20:51:41 1996  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (main): Use exec_reauth() instead of our own.
	(options, main): Add -k/--keep & -s/--su options.
	(options, main): Remove -m/--umask option; use UMASK param instead.
	(main): Get rid of various string vars only used once.

Fri Dec 29 12:16:13 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* loginpr.sh: New program.
	* login.c (main): Add optional shell argument for --retry.
	Add --paranoid/-P option.

	* login.c (main): Don't ask for password by name if only one user.

Thu Dec 28 17:41:11 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c (main, options): Add --retry/-R option.

	* login.c (main): If -f/--no-passwd is specified, get rid of the
	effect of the login executable being setuid/gid.
	Only set the shell proc's owner to an effective uid.

Sun Dec 24 14:26:18 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (main): Move a bunch of stuff into psout() in psout.c.
	* psout.c: New file.

Sat Dec 23 20:49:26 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (main): Allow user to use `-' prefix to invert sort as well.
	(main): Use ps_fmt_set_output_width() to set the output width.

	* login.c (add_utmp_entry): Only remove a prefix from the tty name
	if it's _PATH_DEV.

Thu Dec 21 11:15:42 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (spec_abbrevs, ps_specs): New variables.
	(fmts): Get rid of redundant header specifications.
	(fmt_sortrevs): Variable removed.
	(main): Don't allow sorting on field names any more, just spec
	names (prob ok, since most things ps prints are now spec names).
	(main, options): Rename -o flag to -U for posix compat (ick).

	* login.c (options): Add --no-utmp/-z option.
	(add_utmp_entry): New function.
	(main): Call add_utmp_entry().
	(main): Ivec routines are now idvec routines.
	Include <idvec.h> instead of <ivec.h>.
	(options): --host/-h is now --via/-h.
	(main): Store the host were logged in from via in VIA, in the
	login parameters instead of the child environment; optionally copy
	it into the environment too.
	(main): Enable EXEC_SECURE.
	* Makefile (libutil-libsubst): New hack.
	(login): Depend on -lutil.

	* ps.c (main): Ivec routines are now idvec routines.
	Include <idvec.h> instead of <ivec.h>.
	Use argz functions to store tty_names instead of our own.

Sun Dec 17 00:24:26 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (main, options): If the specified sort field begins with
	`-', reverse the sort.

	* ps.c (main): If there is no current uid, don't try to filter with it.
	(FILTER_NOT_LEADER):  Renamed from FILTER_NSESSLDR.
	(main): Rename ps_not_leader_filter from ps_not_sess_leader_filter.

	* ps.c (main): Use ivec routines instead of ids.
	(make_ids, ids_add, ids_contains): Routines deleted.
	Include <ivec.h>.

Sat Dec 16 22:13:32 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (options): Reformat doc string for --tty option.

	* ps.c (options): Add argument and doc for 'w' option.
	(main): Implement 'w' option.

	* login.c: Zillions of changes.

Tue Dec 12 20:16:22 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* login.c: New file.
	* Makefile (SRCS): Add login.c
	(targets): Add login.
	(login): Depends on ../libshouldbelibc/libshouldbelibc.

Wed Dec  6 15:12:15 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* fsysopts.c (main): Supply the new SEP argument to argz_stringify.
	* showtrans.c (main): Ditto.

	* fsysopts.c (main): Change uses of the INDEX field in argp_state
	structures to use NEXT instead.
	* ps.c (main): Ditto.
	* settrans.c (main): Ditto.
	* showtrans.c (main): Ditto.  Fix default prefix-printing test.
	* storeinfo.c (main): Ditto.

Mon Dec  4 15:41:06 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* storeinfo.c (main): Correctly whether to print prefix by default.
	(options): Fix help strings.

Wed Nov 15 19:56:21 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (main): Use new libps stream type.

Tue Nov 14 18:28:20 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (main): Grow TTY_NAMES properly even when it's empty.

Mon Nov  6 12:41:21 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (ids_add): Increase the size of IDS even when 0.

	* fsysopts.c (main): Use file_get_fs_options, not fsys_get_options.
	(doc): `filesystem' --> `FILESYS'.

Sat Nov  4 19:56:38 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* storeinfo.c (print_info): Use the new FLAGS argument to
	file_get_storage_info.  Add new storage types.

Wed Nov  1 19:30:42 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* settrans.c (main): Change to use the new wierd callback
	interface to fshelp_start_translator.

	* ps.c (options): Add --not-owner/-O option.
	(id_t, struct ids): New type.
	(make_ids, ids_add, ids_contains): New functions.
	(main): Use a struct ids instead of multiple variables to hold the
 	wanted uids list, which renamed to ONLY_UIDS.  Add the NOT_UIDS
 	list to contain the opposite sense, and use it.

	* ps.c (main): Use proc_stat_proc_info instead of proc_stat_info and
	PSTAT_PROC_INFO instead of PSTAT_INFO.

Tue Oct 31 17:57:25 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* fsysopts.c (doc, args_doc): Mention usage without any options.
	(main): If no options are supplied, print existing options.

	* ps.c (fmts): Add RPC field to the -l format.

Mon Oct 30 16:24:37 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (options): --all is -e, not -a.

Mon Oct 23 15:17:42 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* settrans.c (options): Change --force/-f to --goaway/-g.  Add
	flags for killing translators: --recurse/-r, --force/-f, --nosync/-S.
	(doc): New variable.
	(main): Support new flags.  Have some of the options update flag
	words instead of setting variables.

	* storeinfo.c (print_info): Calculate total size/blocks correctly.

Fri Oct 20 15:44:45 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* settrans.c (args_doc): New variable.
	(main): Set ARGZ inside of parse_opt.

	* fsysopts.c (options): FILE --> FILESYS in help msg.
	(args_doc): OPTION --> FS_OPTION, since the usage message already
	uses OPTION to mean those to fsysopts.
	(doc): New variable; give some common choices for FS_OPTION.

Thu Oct 19 19:07:26 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (parse_enum): Use argp_error.

Thu Oct 12 15:22:24 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (parse_enum): Use ARGP_HELP_STD_ERR.

Wed Oct 11 19:03:19 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* ps.c (main): Use realloc on a variable in main instead of
	alloca, since the storage gets used after parse_opt returns.

	* fsysopts.c (main): Use argp_help instead of argp_usage.

Tue Oct 10 15:02:17 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* showtrans.c (options): Converted to argp format.
	(main): Use argp, not getopt.
	(usage, USAGE, SHORT_OPTIONS): Deleted.
	(arg_doc, doc): New variables.
        Include <argp.h> not <getopt.h>.
	* fsysopts.c (options): Converted to argp format.
	(main): Use argp, not getopt.
	(usage, USAGE, SHORT_OPTIONS): Deleted.
	(arg_doc): New variable.
        Include <argp.h> not <getopt.h>.
	* settrans.c (options): Converted to argp format.
	(main): Use argp, not getopt.
	(usage, USAGE, SHORT_OPTIONS): Deleted.
        Include <argp.h> not <getopt.h>.
	* ps.c (options): Converted to argp format.
	(main): Use argp, not getopt.
	(usage, USAGE, SHORT_OPTIONS): Deleted.
	(arg_doc, doc): New variables.
        Include <argp.h> not <getopt.h>.

Fri Oct  6 17:33:01 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* storeinfo.c (print_info): Use the new block_size value returned
	from file_get_storage_info.

Wed Oct  4 18:15:59 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* showtrans.c (usage, options, main): Change -h/--no-header options to
	-p/--prefix and -P/--no-prefix.
	(main): Unless overridden by -p/-P, only print a FILE: prefix when
	there are multiple files on the command line.

Mon Oct  2 19:00:27 1995  Miles Bader  <miles@gnu.ai.mit.edu>

	* Makefile (targets): Add storeinfo.
	(SRCS): Add storeinfo.c.

Fri Sep  1 11:35:12 1995  Miles Bader  <miles@churchy.gnu.ai.mit.edu>

	* settrans.c (main): Use fshelp_start_translator instead of
	start_translator from ../lib.
	* Makefile: Get rid of rules related to ../lib.
	(settrans): Depend on libfshelp.a instead of starttrans.o.

Thu Aug 24 10:44:17 1995  Miles Bader  <miles@churchy.gnu.ai.mit.edu>

	* Makefile (all): New target.
	(ps, settrans, showtrans, fsysopts): Put all dependencies in these
	targets.
	(settrans-HURDLIBS, showtrans-HURDLIBS, ps-HURDLIBS): Removed.

Tue Aug 22 17:56:09 1995  Miles Bader  <miles@churchy.gnu.ai.mit.edu>

	* Makefile (settrans-HURDLIBS, showtrans-HURDLIBS, ps-HURDLIBS):
	Add libshouldbeinlibc.
	(settrans, showtrans, fsysopts, ps): Get rid of things that are
	now in libshouldbeinlibc.
	Get rid of rules dealing with error.o.

Sun Jul 23 15:58:06 1995  Michael I Bushnell  <mib@geech.gnu.ai.mit.edu>

	* Makefile (DIST_FILES): sh.ChangeLog -> shd.ChangeLog.

Fri Jul  7 19:20:21 1995  Michael I Bushnell  <mib@duality.gnu.ai.mit.edu>

	* clri.c (copyright, sccsid): Correct syntax.

Fri Jul  7 18:56:45 1995  Miles Bader  <miles@churchy.gnu.ai.mit.edu>

	* settrans.c (SHORT_OPTIONS): Remove '?' as getopt usurps it.
	(options, main): Use '&' instead of '?' to mean help.

Thu Jul  6 21:04:04 1995  Michael I Bushnell  <mib@duality.gnu.ai.mit.edu>

	* su.c (main, apply_auth_to_loginid, apply_auth_to_pgrp): Remove
 	assignments from inside if tests.

	* sync.c (main): Declare return type.

	* clri.c (copyright, sccsid): Declare unused.
	(main): Correct format for fourth arg in printf call.

	* ps.c (lookup_user): Declare return to be `int' to avoid type
 	clash in use as 4th parameter to parse_numlist.

	* shd.c (run): Remove assignments from inside if tests.
	(command): Likewise.

	* Makefile (special-targets): New var.
	(mount): Provide command.
	(OBJS): New var.
	(shd, su, clri, sync, reboot, halt): List object files here.

Thu Jul  6 16:12:22 1995  Miles Bader  <miles@geech.gnu.ai.mit.edu>

	* settrans.c (main): Give an error message instead of dying when
	no filename argument is given.

Thu Jul  6 15:43:15 1995  Michael I Bushnell  <mib@duality.gnu.ai.mit.edu>

	* Makefile: Removed dependencies that are now automatically
 	generated.

Wed Jul  5 21:18:42 1995  Michael I Bushnell  <mib@duality.gnu.ai.mit.edu>

	* Makefile (ps-HURDLIBS): Renamed from HURDLIBS.
	(ps): Fix dependencies.

Mon Jun 26 16:13:47 1995  Miles Bader  <miles@churchy.gnu.ai.mit.edu>

	* Makefile (CPPFLAGS): Put -I../lib back in.
	Put back the vpath for %.c to ../lib.

Tue Jun  6 13:22:52 1995  Michael I Bushnell  <mib@duality.gnu.ai.mit.edu>

	* Makefile (HURDLIBS): Added libihash.
	(CPPFLAGS): Deleted addition of -I../lib.
	(vpath): Deleted spec.
	(ps): Deleted ihash.o and primes.o.

Thu Jun  1 11:33:47 1995  Miles Bader  <miles@churchy.gnu.ai.mit.edu>

	* Makefile (ps.o, fsysopts.o, showtrans.o, settrans.o): Add
	dependencies on header files.
	(REMHDRS): Define this variable.

Tue May 30 12:17:33 1995  Michael I Bushnell  <mib@duality.gnu.ai.mit.edu>

	* Makefile (SCRS): Removed update.c.
	(targets): Removed update.

Sat May 20 00:51:50 1995  Miles Bader  <miles@churchy.gnu.ai.mit.edu>

	* fsysopts.c (main): Check for a missing filesystem name.
	(main): Tweak the error msgs a bit.

	* fsysopts.c (options, main): Don't use '?' as the --help key.

Mon May 15 20:31:31 1995  Miles Bader  <miles@duality.gnu.ai.mit.edu>

	* Makefile (SRCS, targets): Add fsysopts.

Wed May  3 11:37:39 1995  Miles Bader  <miles@churchy.gnu.ai.mit.edu>

	* ps.c (main, usage, SHORT_OPTIONS, options): Add the -n flag
	(--nominal-fields), which prevents elision of uninteresting fields.
	Also add elision of uninteresting fields...

Tue May  2 17:22:11 1995  Miles Bader  <miles@geech.gnu.ai.mit.edu>

	* ps.c (fmts): Add the SC (suspend count) field to various output fmts.
	(usage, main, SHORT_OPTIONS): Add the (ignored) -w flag for BSD compat.
	(main): Use the new name for ps_fmt_squash: ps_fmt_squash_flags.

Tue May  2 14:37:07 1995  Michael I Bushnell  <mib@duality.gnu.ai.mit.edu>

	* shd.c (reap): Check for ECHILD, not ESRCH.

Wed Apr 26 21:40:57 1995  Miles Bader  <miles@churchy.gnu.ai.mit.edu>

	* settrans.c (main): Allow options before and immediately after
	the node name to be rearranged by getopt without affecting those
	following the translator name.

Fri Apr 14 10:18:34 1995  Miles Bader  <miles@churchy.gnu.ai.mit.edu>

	* mount.sh: Move the test for a valid translator to just before we
	use it.  Gratuitously change the "unknown" value for type to "".
	Don't use `--' when invoking settrans, as getopt doesn't seem to
	be handling it correctly.  Use `usage' not `USAGE'.

Wed Apr 12 14:38:25 1995  Michael I Bushnell  <mib@duality.gnu.ai.mit.edu>

	* Makefile (DIST_FILES): Omit ps.ChangeLog.

Tue Apr 11 15:21:46 1995  Michael I Bushnell  <mib@duality.gnu.ai.mit.edu>

	* Makefile (targets): Changed `sh' to `shd'.
	(SRCS): Changed `sh.c' to `shd.c'.
	* shd.c: Renamed from `sh.c'.

Mon Apr 10 20:01:20 1995  Miles Bader  <miles@churchy.gnu.ai.mit.edu>

	* ps.c (main): Tweak things so that the -t flag works correctly
	for processes whose tty we can't figure out.

Sun Apr  9 14:00:09 1995  Miles Bader  <miles@duality.gnu.ai.mit.edu>

	* su.c (main): Getopt now returns '\001' for non-switch options
	instead of '\0', no doubt to work around an obscure bug in some
	brain-dead system only used by 2 people twice a decade.

Fri Apr  7 11:55:25 1995  Miles Bader  <miles@churchy.gnu.ai.mit.edu>

	* ps.c (parse_enum): Renamed from enum_name.
	(main, usage): Add lots of sysvish options, and generalize some
	existing ones to deal with sysvish usage.  Make -t & -o work.

Thu Apr  6 11:56:23 1995  Miles Bader  <miles@churchy.gnu.ai.mit.edu>

	* ps.c (main): Add the `jobc' (-j) output format from netbsd.

Wed Apr  5 22:10:50 1995  Miles Bader  <miles@churchy.gnu.ai.mit.edu>

	* ps.c (main): When processes are specified on the command line by PID,
	turn off all filtering so that they don't disappear later.  Also
	minor changes in some spec names.

Tue Apr  4 11:32:53 1995  Miles Bader  <miles@churchy.gnu.ai.mit.edu>

	* Makefile: Add showtrans & mount, and uncomment-out su.

	* settrans.c (main): Get rid of the `show passive translator'
	functionality, as this is now done by showtrans.

	* ps.c (main): Make -a imply -g as well, to be compatible with bsd.
	Add the -M (--no-msg-port) switch, which disables all fields that
	would use any process's message port.

	* showtrans.c: New file: Show passive translators.

	* su.c (apply_auth): Use msg_add_auth & msg_del_auth instead of
	add_auth & del_auth.
	(apply_auth_to_pids, apply_auth_to_loginid, apply_auth_to_pgrp):
	Don't use the IDS variable, it's no longer around; I think AUTH is
	the right thing to replace it with.

Tue Apr  4 01:47:57 1995  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* ps.c (main): Treat argument without leading - as if it had one,
 	unless it's a number.

Mon Mar 20 20:17:04 1995  Michael I Bushnell  <mib@duality.gnu.ai.mit.edu>

	* Makefile (ps): Link in ihash.o, error.o, and primes.o too.
	* Makefile (vpath %.c): New decl.

	* ps.c: Include <hurd/ps.h> instead of "ps.h".
	Include <unistd.h>.
	(enum_name): Avoid warning.
	(program_name): New variable.
	(main): Don't set program_invocation_short_name (the library does it
	for us).  Do set program_name.

	* ps.c: Replace with new version by Miles Bader.  See ps.ChangeLog
	for some changes made to the new version before the replacement.
	Old ps.c and ps.ChangeLog are now ps.c.old and ps.ChangeLog.old.
	* Makefile (HURDLIBS): Define, for ps.
	(CPPFLAGS): Define, for ps.
	(ps): Add rule to get library.

Sat Jan 28 15:02:08 1995  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* sh.c (main): Only open /dev/tty if stdin is unreadable.

Wed Nov 16 20:28:40 1994  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* reboot.c: Include unistd.h, stdio.h, not hurd/anything.
	(main): If reboot returns, give error message and return 1.
	* halt.c: Likewise.

Sat Nov 12 21:20:07 1994  Michael I Bushnell  <mib@churchy.gnu.ai.mit.edu>

	* reboot.c (main): Just use the reboot function.
	* halt.c (main): Likewise.

Fri Nov 11 12:05:38 1994  Michael I Bushnell  <mib@churchy.gnu.ai.mit.edu>

	* Makefile (targets): Added reboot and halt.
	(SRCS): Added reboot.c and halt.c.
	* reboot.c: New file
	* halt.c: New file.

	* ps.c (main): Print in shorter format by default; take -v flag to
	print in longer format.

Wed Nov  9 04:43:54 1994  Michael I Bushnell  <mib@geech.gnu.ai.mit.edu>

	* ps.c (time_str): Specify format for decimals correctly.

Wed Nov  9 00:20:09 1994  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* ps.c (time_str): Use %.2d instead of %2d to get 0 pads.

Mon Nov  7 14:15:10 1994  Michael I Bushnell  <mib@churchy.gnu.ai.mit.edu>

	* ps.c (time_str): Don't use floating point conversion;
	it's buggy.

Wed Nov  2 13:34:56 1994  Michael I Bushnell  <mib@geech.gnu.ai.mit.edu>

	* sync.c: New file.
	* Makefile (targets): Added sync.
	(SRCS): Added sync.c.

Thu Oct 27 22:19:29 1994  Michael I Bushnell  <mib@churchy.gnu.ai.mit.edu>

	* ps.c (main): Also print out a field with the number of threads.

Tue Oct  4 19:40:22 1994  Michael I Bushnell  <mib@churchy.gnu.ai.mit.edu>

	* clri.c: New file.
	* Makefile (targets): Added clri.
	(SRCS): Added clri.c.

Sat Oct  1 03:44:55 1994  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* update.c: Take optional arg to specify sleep time.
	Use daemon instead of doing its work by hand.

Fri Sep 30 11:53:53 1994  Michael I Bushnell  <mib@churchy.gnu.ai.mit.edu>

	* update.c: New file.
	* Makefile (SRCS): Added update.c.
	(targets): Added update.

Sat Sep 10 08:22:34 1994  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* settrans.c (main): Give usage message when given no args.
	Use O_NOTRANS in file name lookup.
	Don't use FS_TRANS_EXCL in file_set_translator.
	If given args "FILE -show", get translator and print it out.

Thu Sep  1 11:50:51 1994  Michael I Bushnell  <mib@geech.gnu.ai.mit.edu>

	* settrans.c: New file.
	* Makefile (SRCS): Added settrans.c.
	(targets): Added settrans.

Tue Aug 30 16:40:54 1994  Michael I Bushnell  <mib@geech.gnu.ai.mit.edu>

	* sh.c (run): Use file_name_lookup instead of path_lookup.

Tue Aug 23 10:44:16 1994  Michael I Bushnell  <mib@geech.gnu.ai.mit.edu>

	* Makefile (targets): Comment out `su' until Roland gets it back
	into a usable state.

Mon Aug 22 12:18:09 1994  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* sh.c (main): Open /dev/tty with O_IGNORE_CTTY and fdopen that
	onto stdin/out/err.

Fri Jul 22 12:26:27 1994  Michael I Bushnell  <mib@geech.gnu.ai.mit.edu>

	* Makefile: Rewritten to use new scheme.
